package org.xdprof.listener;

import org.xdprof.data.*;
import org.xdprof.server.*;
import org.xdprof.util.*;

import java.util.*;

public class ListenerCollection implements ServerListener
{
	public ListenerCollection()
	{
		
	}
	
	/**
	 * Adds a connection to each server listener.
	 * @param c the connection to register
	 */
	public void addConnection(Connection c)
	{
		for (Iterator i = m_listeners.iterator(); i.hasNext(); )
		{
			ServerListener sl = (ServerListener) i.next();
			sl.addConnection(c);
		}
	}
	
	/**
	 * Adds a trace for the connection.
	 * @param c the connection
	 * @param t the "latest" trace
	 */
	public void addTrace(Connection c, Trace t)
	{
		for (Iterator i = m_listeners.iterator(); i.hasNext(); )
		{
			ServerListener sl = (ServerListener) i.next();
			sl.addTrace(c, t);
		}	
	}
	
	/**
	 * Removes/unregisters a connection from each listener.
	 * @param c the connection to remove
	 */
	public void removeConnection(Connection c)
	{
		for (Iterator i = m_listeners.iterator(); i.hasNext(); )
		{
			ServerListener sl = (ServerListener) i.next();
			sl.removeConnection(c);
		}	
	}

	public void addServerListener(ServerListener sl)
	{
		m_listeners.add(sl);
	}
	
	private final Vector m_listeners = new Vector();
}
