package org.xdprof.listener;

import org.xdprof.data.*;
import org.xdprof.server.*;
import org.xdprof.util.*;

/**
 * Anything that listens for server events.
 */
public interface ServerListener
{

	/**
	 * Adds a connection to the server.
	 * @param c the connection to register
	 */
	public void addConnection(Connection c);
	
	/**
	 * Adds a trace for the connection.
	 * @param c the connection
	 * @param t the "latest" trace
	 */
	public void addTrace(Connection c, Trace t);
	
	/**
	 * Removes/unregisters a connection.
	 * @param c the connection to remove
	 */
	public void removeConnection(Connection c);

}
