package org.xdprof.listener;

import java.io.*;
import java.net.*;
import java.util.*;

import org.xdprof.data.*;
import org.xdprof.server.*;
import org.xdprof.util.*;

/**
 * A console-based server.
 */
public class ServerText implements ServerListener
{
	private Set m_removed = new HashSet();
	
	/**
	 * Construct on this port.
	 */
	public ServerText()
	{
		//new Server(port, this).start();
	}
	
	public void setPort(int p)
	{
		// do nothing
	}
	
	/**
	 * Removes/unregisters a connection.
	 * @param c the connection to remove
	 */
	public void removeConnection(Connection c)
	{
		Debug.trace("TEXT: Remove", c.toString());
		m_removed.add(c);
	}
	
	/**
	 * Adds a connection to the server.
	 * @param c the connection to register
	 */
	public void addConnection(Connection c)
	{
		Debug.trace("TEXT: Add connection", c);
	}
	
	/**
	 * Adds a trace for the connection.
	 * @param c the connection
	 * @param t the "latest" trace
	 */
	public void addTrace(Connection c, Trace t)
	{
		Assert.assert("Not shut down", !m_removed.contains(c));
		Debug.trace("TEXT: Adding trace for " + c + " " + t.toString());
	}
		
	/**
	 * Start the program.
	 * @param args args[0] is the port number
	 */
	public static void main(String[] args)
	{
		try
		{
			Server.startServer(Integer.parseInt(args[0]), new ServerText());
		}
		catch (Exception e)
		{
			Debug.traceException("main", e);
			System.err.println("Usage: ServerText port");
		}
	}

}
