/*
Copyright (c) 2001, John Lambert jlambert@jlambert.com
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are 
permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of 
conditions and the following disclaimer.

Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution. 

Neither the name of the xdProf project nor the names of its contributors may be used
to endorse or promote products derived from this software without specific prior 
written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
$Header: /xdprof-dll/platform.h 4     5/07/01 12:03a Admin $ 
 */
#ifndef _PLATFORM_H_
#define _PLATFORM_H_


#ifdef WIN32
#include <sstream>
#include <io.h>
#include <winsock2.h>
#include <stdlib.h>
#include <process.h>
#include <windows.h>
#include <winbase.h>
#else
#include <strstream>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>     
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h> 
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h> 
#include <signal.h>
#include <sys/ipc.h>   
#include <sys/sem.h>   
#include <sys/shm.h>
#include <sys/errno.h> 
#include <sys/time.h>  
#include <time.h>

#define _getpid getpid
#define _snprintf snprintf
#define ostringstream ostrstream
#define closesocket close
#endif

#endif //_PLATFORM_H_

