/*
Copyright (c) 2001, John Lambert jlambert@jlambert.com
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are 
permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of 
conditions and the following disclaimer.

Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution. 

Neither the name of the xdProf project nor the names of its contributors may be used
to endorse or promote products derived from this software without specific prior 
written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
$Header: /xdprof-dll/types.h 11    5/09/01 5:29a Admin $ 
 */

#ifndef _TYPES_H_
#define _TYPES_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"

//! ThreadID's identify threads
typedef JNIEnv* ThreadID;

class MethodInfo;
class ThreadInfo;
class ClassInfo;

//! Maps from jmethodID to a MethodInfo object
typedef map<const jmethodID, const class MethodInfo*> MethodMap;

//! Maps from a ThreadID to a ThreadInfo object
typedef map<const ThreadID, class ThreadInfo> ThreadMap;

//! A set of jmethodIDs
typedef set<jmethodID> MethodSet;

typedef jobjectID jclassID;
typedef set<jclassID> ClassSet;
typedef map<jclassID, class ClassInfo> ClassInfoMap;
#include <list>
//! A map from class (jobjectID) to the set of methods that it defines

typedef vector<jmethodID> MethodList;

typedef map<const jobjectID, MethodList > ClassMethopMap;

#endif // _TYPES_H_

